#ifndef __ASMEMORY_H__
#define __ASMEMORY_H__

typedef struct {
  char *str;
  char *link;
} AsLink;

typedef struct {
  char *block;
  int b_max;
  int b_free;
  AsLink *strlink;
  int l_max;
  int l_free;
  st_table *st;
} AsMemory;


AsMemory *asmemory_new(int, int);
void asmemory_dump(AsMemory *, FILE *);
int as_set(AsMemory *, char *, char *);
char *as_get(AsMemory *, char *);

#endif
