#ifndef __NUMSTACK_H__
#define __NUMSTACK_H__

#include <stdio.h>

typedef struct {
  int *stack;
  int max;
  int sp;
} NumStack;

NumStack *numstack_open(int);
void numstack_close(NumStack *);
void numstack_dump(NumStack *, FILE *);

#define numstack_size(_ns) ((_ns)->sp)

#define numstack_clear(_ns) ((_ns)->sp=0)
#define numstack_empty(_ns) ((_ns)->sp==0)
// #define numstack_push(_ns,_v) ((_ns)->stack[(_ns)->sp++]=(_v))
// #define numstack_pop(_ns) ((_ns)->stack[--(_ns)->sp])

void numstack_push(NumStack *, int);
int numstack_pop(NumStack *);

#endif
