/* ʸǼ */

#ifndef __STRING_BANK_H__
#define __STRING_BANK_H__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "st.h"

typedef struct {
  char *all_letter;
  int max_letter;
  int free_letter;
  int *all_word;
  int max_word;
  int free_word;
  st_table *word_entry;
} StringBank;


StringBank *string_bank_new(int, int);
int string_bank_add(StringBank *, char *);
int string_bank_add_n(StringBank *, char *, int);
void string_bank_dump(StringBank *, FILE *fp);
char *string_bank_ref(StringBank *, int);

void string_bank_save(StringBank *, FILE *fp);
StringBank *string_bank_load(FILE *fp);

#endif
