#ifndef __ATYPE_H__
#define __ATYPE_H__

#include <stdio.h>
#include "string_bank.h"
#include "keyword.h"
#include "eucmap.h"

// ===================================================================
// 

// -------------------------------------------------------------------
// γǼ

// RAW ̡STD ɸ̡VAR ѿ FSY ؿ FSM ̣°̤
// CNT ̲ᥫ󥿡
// JUMP jump PHI phi  POP pop 
// BCAT +BCUT !
// SMK  Ȼ ^setmark(*|^|*^) 

typedef struct cnd {
  CndType ctype;
  Sign sign;		// 黻
  union {
    struct {		// RAW  STD ΤȤ
      int word;		// ñƬʸֹ
      int len;		// ʸĹ
    };
    struct {		// VARFSY ΤȤ
      int link;		// VAR 󥯸 PreTerm  BgnNode ؤΥǥ
      int str;		// ѿ/ؿ StringBank ؤΥǥå
      int num;		// ѿֹ
    };
    struct {		// CNT ΤȤ
      int num1;		// cnt<> ο
      CmpType cmp;	// cnt# == (EQ) != (NE)
      int num2;		// ο
    };
    RefType ref;	// SMK ΤȤ
  };
} Cnd;

typedef struct {
  Cnd *cnd;
  int max;
  int free;
} CndBank;


// -------------------------------------------------------------------
// γǼ
// #<>,  cnt<>++

typedef struct {
  NetMemoryType type;
  union {
    int num;
    struct {
      int loc;
      int offset;
    };
  };
} NetMemory;

typedef struct {
  NetMemory *memory;
  int max;
  int free;
} NetMemoryBank;


// -------------------------------------------------------------------
// ϥΡɤγǼ

typedef struct {
  int index_of_arc;	// ArcBank Υǥå
  int num;		// ƱΡɤФƤ륢ο
} BgnNode;

typedef struct {
  BgnNode *bgnode;
  int max;
  int free;
} BgnNodeBank;


// -------------------------------------------------------------------
// γǼ

typedef struct {
  int ed;	// Ρֹ(BgnNodeΥǥå)
  int cnd;	// ֹ (CndBank Υǥå)
  RefType ref;	// Ȼ
  int mem;	//  (NetMemoryBank Υǥå)
} Arc;

typedef struct {
  Arc *arc;
  int max;
  int free;
} ArcBank;


// -------------------------------------------------------------------
// ͥåȥγǼ

typedef struct {
  int name;		// ͥåȥ̾
  int start_node;	// ϥΡ(BgnNodeBank Υǥå)
  int letter_condition;	// ɬܻ̥ӥåȥޥåפΥǥå
  int lc_num;           // ɬܻ̥ӥåȥޥåפθĿ
} Network;

typedef struct {
  Network *network;
  int max;
  int free;
} NetworkBank;


typedef struct {
  EucPrtMapBank *epb;	// ɬܻ̤γǼ
  StringBank    *sb;	// ʸγǼ
  CndBank       *cb;	// γǼ
  NetMemoryBank *nmb;	// γǼ
  BgnNodeBank   *bnb;	// ϥΡɤγǼ
  ArcBank       *ab;	// γǼ
  NetworkBank   *nb;	// ͥåȥγǼ
} AType;


AType *atype_open(int, int, int, int, int, int); // γ
void atype_clear(AType *);		// Ƥꥻå
void atype_close(AType *);		// γ
void atype_convert(AType *, FILE *);	// AեǼ

void atype_dump(AType *, FILE *);	// åѤɽ

void atype_save(AType *, FILE *);  // ꥤ᡼ե¸
AType *atype_load(FILE *);	// ե뤫ꥤ᡼
void atype_strip(AType *);    	// ꥤ᡼Υڤͤ

int atype_cat_atype(AType *, AType*);	// 2ĤΥޥåפ礹



void cnd_bank_print_one(AType *,int, FILE *);

// ѥγϥΡɤ
#define pattern_first_node(_am,_pidx)\
	((_am)->amap->nb->network[(_pidx)].start_node)

#endif
