/*
 * atype2map.c
 *
 */

#include <stdio.h>
#include "string_bank.h"
#include "atype.h"

// ===================================================================
// ͡ʵϤ˱ѹ

#define MAX_NETWORKS	  250000
#define MAX_NODES	25000000
#define MAX_ARCS	25000000
#define MAX_NET_MEMORY	 1000000
#define MAX_CNDS	25000000
#define MAX_IMPBITMAP    5000000  // ɬܻ̥ӥåȥޥåפγǼ

#define MAX_LETTERS	75000000
#define MAX_WORDS	 5000000

// ===================================================================

void show_help()
{
  fprintf(stderr,"Aޥåѡ: atype2map arcfile mapfile\n");
  fprintf(stderr,"                                       version 2005.6/18 by tokuhisa\n");
  fprintf(stderr,"\n");
}


// ===================================================================

int main(int argc, char *argv[])
{
  FILE *fp;
  AType *a;


  // --------------------  --------------------
  if( argc != 3 ){
    show_help();
    exit(1);
  }

  // --------------------  --------------------
  
  a = atype_open(MAX_NETWORKS, MAX_NODES, MAX_ARCS, MAX_NET_MEMORY, MAX_CNDS, MAX_IMPBITMAP);
  a->sb = string_bank_new(MAX_LETTERS, MAX_WORDS);

  // -------------------- A --------------------
  fp = fopen(argv[1],"r");
  atype_convert(a, fp);
  fclose(fp);

  // -------------------- ǧ --------------------
  // atype_dump(a,stdout);

  // --------------------  --------------------
  fp = fopen(argv[2],"w");
  atype_save(a, fp);
  fclose(fp);

  // -------------------- λ --------------------
  atype_close(a);

  return 0;
}
