/* dump_amap.c ƥ */

#include <stdio.h>
#include "string_bank.h"
#include "atype.h"
#include "eucmap.h"

// ===================================================================

int main(int argc, char *argv[])
{
  FILE *fp;
  AType *a;

  if( argc != 2 && argc != 3 ){
    fprintf(stderr,"dump_amap  <Aޥåץե> [-eucmap]\n");
    exit(1);
  }

  fp = fopen(argv[1],"r");
  a = atype_load(fp);
  fclose(fp);

  if( argc == 2 )
    atype_dump(a, stdout);
  else
    eucmap_bank_dump(a->epb, stdout);

  atype_close(a);
  return 0;
}
