/* error.c */

#include <stdio.h>
#include <stdlib.h>
#include "error.h"

static char *errormsg[] =
  {"unknown","malloc failed", "over flowed", "under flowed", "syntax error", "no such file or directory","duplicating declaration","undefined symbol"};

void error(ErrorType et, char *hint)
{
  fprintf(stderr,"%s :%s", errormsg[et], hint);
  fprintf(stderr,"\n");
  exit(et);
}


void warning(char *hint)
{
  fprintf(stderr,"%s\n", hint);
}
