/*
 * eucmap.h
 * ʤ߷
 * 2005.7/12 by tokuhisa
 * first version 2003, April. by tishida
 */

#ifndef __PRETESTER_H__
#define __PRETESTER_H__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "error.h"


// Υӥåȥޥå ------------------------------------------------------
#define EUCMAP_WIDTH 288	// 0x23FF = 1152 Хȡ(uint ñ̤Ǥ 288)
typedef unsigned int EucAllMap[EUCMAP_WIDTH];

#define eucmap_bitmap_clear(bm)\
	memset(bm, 0, sizeof(unsigned int) * EUCMAP_WIDTH )

void eucmap_dump_bitmap(EucAllMap, FILE *);


// ʬӥåȥޥåѾ ------------------------------------------------
typedef struct {
  int index;
  unsigned int pmap;
} EucPrtMap;

typedef struct {
  EucPrtMap *pmap;
  int max;
  int free;
} EucPrtMapBank;

EucPrtMapBank *eucmap_bank_open(int);
void eucmap_bank_clear(EucPrtMapBank *);
void eucmap_bank_close(EucPrtMapBank *);

void eucmap_bank_dump(EucPrtMapBank *, FILE *);
void eucmap_bank_save(EucPrtMapBank *, FILE *);
EucPrtMapBank *eucmap_bank_load(FILE *);
void eucmap_bank_strip(EucPrtMapBank *);

// ----------------------------------------------------------------------
// ɬܻ̤ӥåȥޥåפ
// ʸɤ
void eucmap_create_bitmap(unsigned char *, int, EucAllMap);
void eucmap_set_bitmap(EucAllMap, EucPrtMapBank *, int *, int *);

// ʤ߷ϤǤν
int eucmap_check_bitmap_including(EucAllMap, EucPrtMapBank *, int, int);


void eucmap_decode(int, unsigned int);

#endif
