/* scanner.c  ϥ֥롼 */

// ====================================================================
// 

// ------------------------------------------------------------------
// ü

// ʸ / +
int scan_BORDER(char *line, int bg)
{
  if( line[bg] == '/' )
    return 1;
  if( line[bg] == '+' )
    return 1;
  return 0;
}

// ʸ end
int scan_END(char *line, int bg)
{
  if( (line[bg] == 'e' || line[bg] == 'E') &&
      (line[bg+1] == 'n' || line[bg+1] == 'N') &&
      (line[bg+2] == 'd' || line[bg+1] == 'D') )
    return 3;
  else
    return 0;
}

// ʸ loc
int scan_LOC(char *line, int bg)
{
  if( (line[bg] == 'l') && (line[bg+1] == 'o') && (line[bg+2] == 'c') )
    return 3;
  else
    return 0;
}


// ʸ [?]
int scan_MARK(char *line, int bg)
{
  if( line[bg++] == '[' )
    if( line[bg++] != ']' )
      if( line[bg++] == ']' )
	return 3;
  
  return 0;
}

// ʸ nil
int scan_NIL(char *line, int bg)
{
  if( line[bg] == 'n' )
    if( line[bg+1] == 'i' )
      if( line[bg+2] == 'l' )
	return 3;
  return 0;
}

// ʸ phi
int scan_PHI(char *line, int bg)
{
  if( line[bg] == 'p' )
    if( line[bg+1] == 'h' )
      if( line[bg+2] == 'i' )
	return 3;
  return 0;
}


// ------------------------------------------------------------------
// 

// EUCʸ
int scan_EUCS(char *line, int bg)
{
  int p;

  if( (line[bg] & 0x80) != 0 ){
    p = 1;
    while( (line[bg+p] & 0x80) != 0 ){
      p += 1;
    }
    return p;
  } else
    return 0;
}

// Ⱦʸե٥å
int scan_LALPHA(char *line, int bg)
{
  if( (('A' <= line[bg]) && (line[bg] <= 'Z')) || (line[bg] == '_') )
    return 1;
  else
    return 0;
}

// Ⱦʸե٥å
int scan_LALPHAS(char *line, int bg)
{
  int p;

  if( ('A' <= line[bg] && line[bg] <= 'Z') || (line[bg] == '_') ){
    p = 1;
    while( ('A' <= line[bg+p] && line[bg+p] <= 'Z') || (line[bg+p] == '_') ){
      p += 1;
    }
    return p;
  } else
    return 0;
}

// ʸ
int scan_NOTRETS(char *line, int bg)
{
  int len;

  len = 0;
  while( line[bg + len] != '\n' )
    len += 1;
  return len;
}

// Ⱦѿե٥å
int scan_NUMALPHA(char *line, int bg)
{
  if( ('0' <= line[bg] && line[bg] <= '9') ||
      ('a' <= line[bg] && line[bg] <= 'z') ||
      ('A' <= line[bg] && line[bg] <= 'Z') || 
      (line[bg] == '_') )
    return 1;
  else
    return 0;
}

// Ⱦѿե٥åȡɥå
int scan_NUMALPHADOT(char *line, int bg)
{
  if( ('0' <= line[bg] && line[bg] <= '9') ||
      ('a' <= line[bg] && line[bg] <= 'z') ||
      ('A' <= line[bg] && line[bg] <= 'Z') ||
      (line[bg] == '.') || (line[bg] == '_') )
    return 1;
  else
    return 0;
}

// Ⱦѿե٥å
int scan_NUMALPHAS(char *line, int bg)
{
  int p;

  p = 0;
  while( ('0' <= line[bg] && line[bg] <= '9') ||
	 ('a' <= line[bg] && line[bg] <= 'z') ||
	 ('A' <= line[bg] && line[bg] <= 'Z') ||
	 ('_' == line[bg]) ){
    p += 1;
    bg += 1;
  }
  return p;
}

// Ⱦѿ
int scan_NUMS(char *line, int bg)
{
  int p;

  if( '0' <= line[bg] && line[bg] <= '9' ){
    p = 1;
    while( '0' <= line[bg+p] && line[bg+p] <= '9' ){
      p += 1;
    }
    return p;
  } else
    return 0;
}

// ȾѾʸե٥å
int scan_SALPHAS(char *line, int bg)
{
  int p;

  if( ('a' <= line[bg] && line[bg] <= 'z') || (line[bg] == '_') ){
    p = 1;
    while( ('a' <= line[bg+p] && line[bg+p] <= 'z') || (line[bg+p] == '_') ){
      p += 1;
    }
    return p;
  } else
    return 0;
}
