/* stype.h
 * S-Type եȥޥåץե
 *
 * 2005.6/19 by tokuhisa
 */

#ifndef __STYPE_H__
#define __STYPE_H__

#include <stdio.h>
#include "string_bank.h"
#include "keyword.h"

typedef struct {
  int name;	// ̾StringBank Υǥå
  int dl;	// DefLineBank Ƭǥå
  int dl_num;	// DefLine θĿ
} PreTerm;

typedef struct {
  PreTerm *preterm;
  int max;
  int free;
} PreTermBank;

typedef struct {
  Sign   sign;		// positive term  negative term 
  LCType lctype;	// ̾Υס̵̡ɸ
  int    lcstr;		// ̾λ̡StringBankΥǥå
  Exst   pctype;	// ʻ쥳ɾ̵ͭ
  char   pc[4];		// ʻ쥳ɾ
  Exst   sctype;	// ̣°̵ͭ
  int    scidx;		// ̣°ƬǥåSemCBank
  int    scnum;		// ̣°θĿ
} DefLine;

typedef struct {
  DefLine *dline;
  int max;
  int free;
} DefLineBank;


typedef struct {
  Sign sign;		// 黻Ҥ̵ͭ
  int cat;		// ̣°ΥƥꡢNIIM ʤ(StringBank)
  SValType type;	// ̣°ͤΥ
  int val;		// ̣°(StringBank)
} SemConst;

typedef struct {
  SemConst *semc;
  int max;
  int free;
} SemCBank;

typedef struct {
  StringBank *sb;
  PreTermBank *ptb;
  DefLineBank *dlb;
  SemCBank *scb;
} SType;



SType *stype_open(int, int, int);	// ν
void stype_clear(SType *);		// ֤ξõ
void stype_close(SType *);		// γ
void stype_dump(SType *, FILE *);	// ֤ν
void stype_save(SType *, FILE *);	// SޥåפΥ
SType *stype_load(FILE *);		// SޥåפΥ
void stype_strip(SType *);		// Max Ǿ¤ˤ
void stype_convert(SType *, FILE *);	// Sե뤫ɤ߹



#endif
