/* stype2map.c  Sե뤫SޥåפѴ 2005.6/19 by tokuhisa */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "string_bank.h"
#include "scanner.h"
#include "stype.h"

// -------------------------------------------------------------------

#define MAX_LETTER	75000000
#define MAX_WORD	 5000000

#define MAX_PRETERM	10000		// üο
#define MAX_TERMLINE	50000		// Ԥο
#define MAX_ATTR	50000		// ̣°

// ===================================================================

void show_help()
{
  fprintf(stderr,"Sޥåѡstype2map stypefile mapfile\n");
  fprintf(stderr,"                                      version 2005.6/19 by tokuhisa\n");
  fprintf(stderr,"\n");
}


// ===================================================================

int main(int argc, char *argv[])
{
  FILE *fp;
  SType *s;

  // --------------------  --------------------
  if( argc != 3 ){
    show_help();
    exit(1);
  }

  // --------------------  --------------------
  s = stype_open(MAX_PRETERM, MAX_TERMLINE, MAX_ATTR);
  s->sb = string_bank_new(MAX_LETTER, MAX_WORD);

  // -------------------- S --------------------
  fp = fopen(argv[1],"r");
  stype_convert(s, fp);
  fclose(fp);

  // -------------------- ǧ --------------------
  // stype_dump(s, stdout);

  // --------------------  --------------------
  fp = fopen(argv[2],"w");
  stype_strip(s);
  stype_save(s, fp);
  fclose(fp);

  // -------------------- λ --------------------
  stype_close(s);

  return 0;
}
